<template>
  <div class="flex justify-center items-center pt-6">
    <div class="w-full max-w-xs">
      <form class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4">
        <div class="mb-4">
          <label
            class="block text-gray-700 text-sm font-bold mb-2"
            for="username"
          >
            Usuario
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="username"
            type="text"
            placeholder="Nombre de usuario"
            v-model="username"
          />
        </div>
        <div class="mb-6">
          <label
            class="block text-gray-700 text-sm font-bold mb-2"
            for="password"
          >
            Contraseña
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 mb-3 leading-tight focus:outline-none focus:shadow-outline"
            id="password"
            type="password"
            placeholder="Contraseña"
            v-model="password"
          />
        </div>
        <div class="flex items-center justify-between">
          <button
            class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
            type="button"
            @click="login"
          >
            Iniciar sesión
          </button>
        </div>

        <div
          v-show="errorLogin"
          class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 mt-5 rounded relative"
          role="alert"
        >
          <strong class="font-bold">Error! </strong>
          <ul>
            <li v-for="error in msjErrorLogin" :key="error">{{ error }}</li>
          </ul>
        </div>
      </form>
      <p class="text-center text-gray-500 text-xs">
        &copy; 2023 Genaro Muñoz obregón. Para Nu image.
      </p>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Swal from "sweetalert2";
export default {
  data() {
    return {
      username: "",
      password: "",
      errorLogin: 0,
      msjErrorLogin: [],
    };
  },
  methods: {
    login() {
      if (this.validateForm()) {
        return;
      }
      axios
        .post(process.env.VUE_APP_API_URL + "login", {
          username: this.username,
          password: this.password,
        })
        .then((res) => {
          if (res.data.status == "Success") {
            const token = res.data.token;
            this.$store.dispatch("saveToken", token);
            this.$router.push("/");
            this.$router.go("/");
          } else if (res.data.status == "Error") {
            Swal.fire({
              icon: "error",
              title: "Something went wrong",
              text: "Please verify the login details",
            });
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    validateForm() {
      this.errorLogin = 0;
      this.msjErrorLogin = [];

      if (this.username == "") {
        this.msjErrorLogin.push("Usuario no puede ser vacio");
      }

      if (this.password == "") {
        this.msjErrorLogin.push("Password no puede ser vacio");
      }

      if (this.msjErrorLogin.length) this.errorLogin = 1;

      return this.errorLogin;
    },
  },
};
</script>

<style></style>
